# -*- coding: utf-8 -*-
import os,Cookie,cgi

from chain.chain import *
from database.dbobjects import *
from utils import xslt,getvalue,webutil,convert_dict, convert_value_dict, encodeXMLString, decodeXMLString

import config

class CGIFilter(Module):
    def do(self,chain):
        
        for k,v in os.environ.items():
            webutil.dict[k] = v
        
        # Setup Environment
        chain.env = Environment()

        chain.env.db_facade = DBFacade()
        if config.db_type == 1:
            chain.env.db_facade.OpenFile(config.db_file)
        elif config.db_type == 2:
        	chain.env.db_facade.OpenDirectory(config.db_directory)
        else:
            chain.env.db_facade.Open(config.db_config_url)

        
        # Setup Request
        chain.env.request.cookies = Cookie.SimpleCookie(webutil.GetCookie())
        chain.env.request.form = cgi.FieldStorage()

        for k,v in os.environ.items():
            chain.env.request.header[k] = v
        
        # TODO FIX THIS
        chain.env.request.requested_uri = chain.env.request.header["REQUEST_URI"]
        chain.env.request.script_uri = chain.env.request.header["SCRIPT_NAME"]
        chain.env.request.base_uri = config.base_uri
        
        # Setup Response
        chain.env.response.cookies = Cookie.SimpleCookie()
        chain.env.response.header = {}
        
        chain.doNext()
        
        chain.env.Terminate()
        chain.env.db_facade.Commit()
        chain.env.db_facade.Close()
        
        # Do Output
        for k,v in chain.env.response.header.items():
            print "%s: %s" % (k,v)
        if len(chain.env.response.cookies.keys()) > 0:
            print chain.env.response.cookies.output()
        print ""
        # Print Body
        print chain.env.response.buffer

class PlayActionWebserverFilter(Module):
    def __init__(self,rfile,wfile,fs,headers,cgi_env,request_handler):
        self.rfile = rfile
        self.wfile = wfile
        self.fs = fs
        self.headers = headers
        self.cgi_env = cgi_env
        self.request_handler = request_handler

    def do(self,chain):
        # Setup Environment
        chain.env = Environment()

        # ZODB .
        chain.env.db_facade = DBFacade()
        if config.db_type == 1:
            chain.env.db_facade.OpenFile(config.db_file)
        else:
            chain.env.db_facade.Open(config.db_config_url)

        webutil.dict = self.cgi_env
        # Setup Request
        chain.env.request.cookies = Cookie.SimpleCookie(webutil.GetCookie())
        chain.env.request.form = self.fs
        
        for k,v in self.cgi_env.items():
            chain.env.request.header[k] = v
        
        chain.env.request.path_info = chain.env.request.header["PATH_INFO"]
        
        # Setup Response
        chain.env.response.cookies = Cookie.SimpleCookie()
        chain.env.response.header = {}

        #chain.env.request.requested_uri = chain.env.request.header["REQUEST_URI"]
        chain.env.request.script_uri = chain.env.request.header["SCRIPT_NAME"]
        chain.env.request.base_uri = config.base_uri
        
        chain.doNext()
        
        chain.env.Terminate()
        chain.env.db_facade.Commit()
        chain.env.db_facade.CloseConnection()
        
        self.request_handler.send_response(200)        
        # Do Output
        for k,v in chain.env.response.header.items():
            self.request_handler.send_header(k,v)
        if len(chain.env.response.cookies.keys()) > 0:
            print >> self.wfile, chain.env.response.cookies.output()
        self.request_handler.end_headers()
        # Print Body
        print >> self.wfile, chain.env.response.buffer
        
class Request:
    template = """
    <request>
        <script-uri><![CDATA[%(script_uri)s]]></script-uri>
        <request-uri><![CDATA[%(request_uri)s]]></request-uri>
        <base-uri><![CDATA[%(base_uri)s]]></base-uri>
        %(forms)s
        %(cookies)s
        %(headers)s
    </request>
    """
    """
     û.
    """
    def __init__(self, env, buffer):
        self.env = env
        self.buffer = buffer
        self.requested_uri = ""
        self.script_uri = ""
        self.base_uri = ""
        self.cookies = None
        self.form = None
        self.header = {}
    """
     û XML ȯ.
    """
    def toXML(self):
        if not self.form == None:
            form_xml = convert_value_dict(self.form,tag_name="form")
        else:
            form_xml = ""
        if not self.cookies == None:
            cookie_xml = convert_value_dict(self.cookies,tag_name="cookie")
        else:
            cookie_xml = ""
        
        header_xml = convert_dict(self.header,tag_name="header")
        
        return Request.template % {"script_uri":self.script_uri,"request_uri":self.requested_uri,"base_uri":self.base_uri,\
            "forms":form_xml,"cookies":cookie_xml,"headers":header_xml}

    
class Response:
    template = """
    <response>
        %(cookies)s
        %(headers)s
    </response>
    """
    """
     .
    """
    def __init__(self, env, buffer):
        self.env = env
        self.render_mode = "xslt"
        self.buffer = buffer
        self.cookies = None
        self.header = {}

    def toXML(self):
        if not self.cookies == None:
            cookie_xml = convert_value_dict(self.cookies,tag_name="cookie")
        else:
            cookie_xml = ""
        
        header_xml = convert_dict(self.header,tag_name="header")
        
        return Response.template % {"cookies":cookie_xml,"headers":header_xml}
        
class Session:
    """
     Ÿ Ŭ.
    """
    def __init__(self):
        self._session_values = {}
        self._is_dirty = 0
    def load(self, session_string):
        # TODO: Security Issue!!!
        import cPickle
        self._session_values = cPickle.loads(session_string)
    
    def dump(self):
        # TODO: Security Issue!!!
        import cPickle
        return cPickle.dumps(self._session_values)
    
    def get(self, name):
        if self._session_values.has_key(name):
            return self._session_values[name]
    
    def get_dict(self):
        return self._session_values
        
    def set(self,name,value):
        self._is_dirty = 1
        self._session_values[name] = value
    
    def is_dirty(self):
        return self._is_dirty
    
    def toXML(self):
        return convert_dict(self.get_dict(),tag_name="session")
    
class Environment:
    """
    ü ȯ Ÿ ü. Request/Response DBFacade  ִ´.
    """
    def __init__(self):
        """
         ʱȭ
        """
        request_buffer = ""
        response_buffer = ""
        
        #Request/Response .
        self.request = Request(self, request_buffer)
        self.response = Response(self, response_buffer)
        self.session = Session()
    def Terminate(self):
        pass
    
class ContentRunner(EndPoint):
    def doEnd(self,chain):
        """
        URL - ContentModule List    site_config.py  Ͽ, ͸ о;Ѵ.
        ⼭  ״ ContentModule Ű   ޾ƿ⸸ ϸ ȴ.
        """
        path = webutil.GetPathInfo()
        # split with /
        uri_delim = "/"
        splited_path = path.split(uri_delim)
        # get application_id
        if len(splited_path) > 1:
            application_id = splited_path[1]

            module_uri = uri_delim + uri_delim.join(splited_path[2:])
        else:
            application_id = "default"
            module_uri = "/"
        module_results = ""
        result_true_by_pass = ""
        for application_entry in config.application_config:
            if application_entry[0] == application_id:
                for module in application_entry[1]:
                    # TODO: need to exception handling on running
                    result = module.Run(application_id, chain.env, module_uri)
                    if chain.env.response.render_mode == "truebypass":
                        result_true_by_pass += str(result)
                    tagname = module.GetTagName()
                    module_results += "<%s>%s</%s>" % (tagname, result, tagname)
        # TODO: Create Result XML (cookie, session)
        request_xml = chain.env.request.toXML()
        response_xml = chain.env.response.toXML()
        session_xml = chain.env.session.toXML()

        #site_name = "Crow's Maniacal World"
        #site_description = "Crow's Maniacal World"
        #site_author = "CrowMania"

        site_info_xml_template="""
        <site-info>
            <site-name>%(site_name)s</site-name>
            <site-description>%(site_description)s</site-description>
            <site-author>%(site_author)s</site-author>
            <site-language>%(site_language)s</site-language>
        </site-info>
        """
        site_info_xml = site_info_xml_template % \
            {\
            "site_name" : config.site_name,\
            "site_description" : config.site_description,\
            "site_author" : config.site_author,\
            "site_language" : config.site_language,\
            }
        if chain.env.response.render_mode != "truebypass":
            chain.env.response.buffer +=  "<page application-id=\"%s\">%s %s %s %s %s </page>" % (application_id, site_info_xml,module_results, request_xml, response_xml, session_xml)
        else:
            chain.env.response.buffer = result_true_by_pass

class SessionFilter(Module):
    def do(self,chain):
        # if there are any session loads up it.
        if chain.env.request.cookies.has_key('PLAYACTION2_SESSION'):
            chain.env.session.load(getvalue(chain.env.request.cookies,'PLAYACTION2_SESSION'))
        
        # check authenticate enable
        if chain.env.request.form.has_key("auth_password"):
            auth_password = chain.env.request.form["auth_password"].value
            if config.auth_method == 'plain' and config.auth_password == auth_password:
                chain.env.session.set("is_auth",1)
            if config.auth_method == 'md5':
		import md5
		m = md5.new()
		m.update(auth_password)
		input_password = m.hexdigest()
		if config.auth_password == input_password:
                	chain.env.session.set("is_auth",1)
        
        chain.doNext()

        # if there are any session dumps it.
        if chain.env.session.is_dirty():
            chain.env.response.cookies['PLAYACTION2_SESSION'] = chain.env.session.dump()

class XSLTFilter(Module):
    def do(self,chain):
        chain.doNext()
        if chain.env.response.render_mode == "xslt" and chain.env.request.form.has_key("debug"):
            chain.env.response.render_mode = "bypass"
            
        if chain.env.response.render_mode == "xslt":
            xml_response = "<?xml version=\"1.0\" encoding=\"euc-kr\"?>" + chain.env.response.buffer
            processed_response = xslt.xsltproc(config.xslt_path,xml_response)
            chain.env.response.buffer = processed_response
            chain.env.response.header["Content-Type"] = "text/html"
            
        elif chain.env.response.render_mode == "rss":
            xml_response = "<?xml version=\"1.0\" encoding=\"euc-kr\"?>" + chain.env.response.buffer
            processed_response = xslt.xsltproc(config.rss_xslt_path,xml_response)
            chain.env.response.buffer = processed_response
            chain.env.response.header["Content-Type"] = "text/xml"
            
        elif chain.env.response.render_mode == "bypass":
            chain.env.response.buffer = "<?xml version=\"1.0\" encoding=\"euc-kr\"?>" + chain.env.response.buffer 
            chain.env.response.header["Content-Type"] = "text/xml"
            
        elif chain.env.response.render_mode == "truebypass":
            pass
        
        else:
            pass
            
class PACASChain(Chain):
    def __init__(self):
        modules = [CGIFilter(), XSLTFilter(),SessionFilter()]
        Chain.__init__(self,modules, endpoint = ContentRunner())
        self.reset()

class WebserverPACASChain(Chain):
    def __init__(self,rfile,wfile,fs,headers,cgi_env,request_handler):
        modules = [PlayActionWebserverFilter(rfile,wfile,fs,headers,cgi_env,request_handler), XSLTFilter(),SessionFilter()]
        Chain.__init__(self,modules, endpoint = ContentRunner())
        self.reset()
    
