# -*- coding: utf-8 -*-
import ZODB
import Persistence
import time
from BTrees import OOBTree
from BTrees.Length import Length
from ZODB.config import storageFromURL
from ZODB import FileStorage, DB,PersistentList

class RecentReply(Persistence.Persistent):
	def __init__(self, posting_id, reply_seq, description):
		self.posting_id = posting_id
		self.reply_seq = reply_seq
		self.description = description

def get_new_sequence (db,seq_name): 
    """
    sequence  .
    sequence_name شϴ sequence   ´.
    (Ŭ sequence ϸ )
    """
    conn = db.open() 
    dbroot = conn.root() 
    t = conn.getTransaction() 
    t.begin() 
    if not dbroot.has_key(seq_name): 
        dbroot[seq_name] = Length() 
    length = dbroot[seq_name] 
    length.change(1) 
    t.commit() 
    return length.value

singleton_database = None

class DBFacade:
    """
    DB operation .
    """
    def Open(self, config_url):
        """
        ͺ̽ .
        Ͽ о 
        """
        global singleton_database
        if singleton_database == None:
	        self.storage = storageFromURL(config_url)
	        self.db = DB(self.storage)
	        singleton_database = self.db
	        self.conn = self.db.open()
        else:
        	#print "Using already connected db"
	        self.db = singleton_database
	        self.conn = self.db.open()
        self.Init()

    def OpenFile(self, file_storage_path):
        """
        ͺ̽ .
        ׳ Ͽ о .
        """
        global singleton_database
        if singleton_database == None:
	        self.storage = FileStorage.FileStorage(file_storage_path)
	        self.db = DB(self.storage)
	        singleton_database = self.db
	        self.conn = self.db.open()
        else:
        	#print "Using already connected db"
	        self.db = singleton_database
	        self.conn = self.db.open()
        self.Init()
    def OpenDirectory(self, directory_storage_path):
    	"""
    	丮 丮 .
    	"""
    	from DirectoryStorage.Full import Full
    	from DirectoryStorage.Filesystem import Filesystem
    	global singleton_database
    	if singleton_database == None:
    		fs = Filesystem(directory_storage_path)
    		self.storage = Full(fs)
    		self.db = DB(self.storage)
    		singleton_database = self.db
    		self.conn = self.db.open()
    	else:
    		self.db = DB(self.storage)
    		self.conn = self.db.open()
    	self.Init()
		
    def Init(self):
		"""
		 ̽ ʱȭ. ZODB  ʱȭѴ.
		"""
		dbroot = self.conn.root()
		
		# checking author index
		if not dbroot.has_key("playaction2_authors"):
			# Creating new BTree for Authors
			dbroot["playaction2_authors"] = OOBTree.OOBTree()
		self.authors = dbroot["playaction2_authors"]
		
		# checking wiki pages index
		if not dbroot.has_key("playaction2_wiki_pages"):
			# Creating new BTree for Wiki Pages
			dbroot["playaction2_wiki_pages"] = OOBTree.OOBTree()
		self.pages = dbroot["playaction2_wiki_pages"]

		# checking wiki pages link cache
		if not dbroot.has_key("playaction2_wiki_pages_link_cache"):
			# Creating new BTree for Wiki Pages
			dbroot["playaction2_wiki_pages_link_cache"] = OOBTree.OOBTree()
		self.pages_link_cache = dbroot["playaction2_wiki_pages_link_cache"]
		
		# checking blog postings index
		if not dbroot.has_key("playaction2_blog_postings"):
			# Creating new BTree for Blog Postings
			dbroot["playaction2_blog_postings"] = OOBTree.OOBTree()
		self.postings = dbroot["playaction2_blog_postings"]

		# checking blog replies index
		#if not dbroot.has_key("playaction2_blog_replies"):
		#	# Creating new BTree for Blog Postings
		#	dbroot["playaction2_blog_replies"] = OOBTree.OOBTree()
		#self.replies = dbroot["playaction2_blog_replies"]
		
		# checking blog day by day index
		if not dbroot.has_key("playaction2_blog_daily_postings"):
			# Creating new BTree for Daily Postings
			dbroot["playaction2_blog_daily_postings"] = OOBTree.OOBTree()
		self.daily_postings = dbroot["playaction2_blog_daily_postings"]

		# checking blog monthly index
		if not dbroot.has_key("playaction2_blog_monthly_postings"):
			# Creating new BTree for Monthly Postings
			dbroot["playaction2_blog_monthly_postings"] = OOBTree.OOBTree()
		self.monthly_postings = dbroot["playaction2_blog_monthly_postings"]
		
		#checking categories		
		if not dbroot.has_key("playaction2_blog_categories"):
			dbroot["playaction2_blog_categories"] = OOBTree.OOBTree()
		self.categories = dbroot["playaction2_blog_categories"]
		
		if not self.categories.has_key("__uncategoried"):
			self.categories["__uncategoried"] = OOBTree.OOBTree()

		if not self.categories.has_key("__drafts"):
			self.categories["__drafts"] = OOBTree.OOBTree()

		# checking starred postings
		if not dbroot.has_key("playaction2_blog_starred_postings"):
			# Creating new BTree for Monthly Postings
			dbroot["playaction2_blog_starred_postings"] = OOBTree.OOBTree()
		self.starred_postings = dbroot["playaction2_blog_starred_postings"]

	  	# checking recent informations
		if not dbroot.has_key("playaction2_blog_recent_informations"):
			# Creating new BTree for Recent Information container
			dbroot["playaction2_blog_recent_informations"] = OOBTree.OOBTree()
		self.recent_infos = dbroot["playaction2_blog_recent_informations"]
		
		if not self.recent_infos.has_key("blog_recent_replies"):
			self.recent_infos["blog_recent_replies"] = PersistentList.PersistentList()
		self.recent_blog_reply_infos = self.recent_infos["blog_recent_replies"]
		

    def Commit(self):
        """
          ϱ.
        """
        get_transaction().commit()

    def Abort(self):
        """
          ϱ.
        """
        get_transaction().abort()
        
    def CloseConnection(self):
    	"""
    	ĿؼǸ ݱ.
    	"""
    	self.conn.close()
    	
    def Close(self):
        """
        ͺ̽ ݱ.
        """
        self.conn.close()
        self.db.close()
        self.storage.close()
        
class DBAuthor(Persistence.Persistent):
    """
    PlayAction2   Ŭ.
    """
    def __init__(self,loginmail,passwd,nick,signature):
        """
         . 
        loginmail : ڰ α   ϴ ̸.(same as ID)
        passwd :  ȣ.
        nick :  ʸ.
        signature :  .
        """
        self.loginmail = loginmail
        self.passwd = passwd
        self.nick = nick
        self.signature = signature

class DBPage(Persistence.Persistent):
    """
    PlayAction2 Wiki   Ŭ.
       Ŭ  ̸,   .
    """
    def __init__(self, author, pagename,db):
        """
         .
        author :  νϽ.
        pagename :   ̸.
        """
        #TODO: pagename confliction ó ʿ.
        self.serial_id = get_new_sequence(db,"page_serial_id")
        self.pagename = pagename
        self.author = author
        self.created_time = time.time()
        self.page_bodies = OOBTree.OOBTree()

    def GetRecentPageBody(self):
        """
         ֱ  ´.
        """        
        return self.page_bodies[self.page_bodies.maxKey()]

    def AddPageBody(self,page_body,db):
    	page_body_id = get_new_sequence(db,"page_body_id")
    	self.page_bodies[page_body_id] = page_body

class DBPageBody(Persistence.Persistent):
    """
    PlayAction2 Wiki    Ŭ.
         ⿡  ȴ.
      ⿡ ´.
    """
    def __init__(self,author,page,data,db):
        """
         .
        author:  νϽ.
        page :  νϽ.
        created_time :  ð.
        data :  .
        """
        self.data = data
        self.author =  author
        self.created_time = time.time()
        self.page = page

class DBPosting(Persistence.Persistent):
	"""
	PlayAction2 Blog   Ŭ.
	 .
	  ⿡ ´.
	trackback_from ̱  ִ  Ʈ.
	trackback_to_list ̱  Ʈ Ǿ.
	"""
	def __init__(self,author,title,content,category_key,db):
		"""
		 .
		author:  νϽ.
		created_time :  ð.
		content :  .
		"""
		self.author =  author
		self.created_time = time.time()
		self.modified_time = self.created_time
		self.content = content
		self.tracked_from_list = PersistentList.PersistentList()
		self.tracked_to_list = None
		self.replies = PersistentList.PersistentList()
		self.posting_id = get_new_sequence(db,"playaction2_posting_id")
		self.title = title
		self.category_key = category_key
		
	"""
	Reply߰.
	"""
	def AddReply(self,reply,db):
		self.replies.append(reply)
		return len(self.replies)-1

class DBReply(Persistence.Persistent):
	def __init__(self,writer_name,writer_contact,content,passwd,db):
		self.writer_name = writer_name
		self.writer_contact = writer_contact
		self.content = content
		self.passwd = passwd
		self.created_time = time.time()

class DBCategory(Persistence.Persistent):
	def __init__(self, category_key, category_name, category_desc, db):
		self.category_name = category_name
		self.category_key = category_key
		self.category_description = category_desc
		self.category_postings =OOBTree.OOBTree()

class DBTrackback(Persistence.Persistent):
	def __init__(self, title, excerpt, url_info, blog_name):
		self.title = title
		self.excerpt = excerpt
		self.url = url_info
		self.blog_name = blog_name
		