from database.dbobjects import *
from blog.blogutils import *

import config

db_facade = DBFacade()
if config.db_type == 1:
	db_facade.OpenFile(config.db_file)
else:
	db_facade.Open(config.db_config_url)

for (id, posting) in db_facade.postings.items():
	found = False
	for (category_id, category) in db_facade.categories.items():
		if category_id != "__uncategoried":
			if id in category.category_postings.keys():
				found = True
		else:
			if id in category.keys():
				found = True
	if found == False:
		print str(id) + " posting is not on categories so put it on uncategoried"
		db_facade.categories["__uncategoried"][id] = posting

	found = False
	daily_key = make_daily_key(posting.created_time)

	if not db_facade.daily_postings.has_key(daily_key):
		db_facade.daily_postings[daily_key] = OOBTree.OOBTree()
	
	if not (id in db_facade.daily_postings[daily_key].keys()):
		print str(id) + " posting is not on its daily archive so put it "
		db_facade.daily_postings[daily_key][id] = posting

	found = False
	monthly_key = make_monthly_key(posting.created_time)

	if not db_facade.monthly_postings.has_key(monthly_key):
		db_facade.monthly_postings[monthly_key] = OOBTree.OOBTree()
	
	if not (id in db_facade.monthly_postings[monthly_key].keys()):
		print str(id) + " posting is not on its monthly archive so put it"
		db_facade.monthly_postings[monthly_key][id] = posting
db_facade.Commit()
db_facade.Close()