<?xml version="1.0" encoding="euc-kr"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	xmlns:str="http://exslt.org/strings"
>
	<xsl:import href="str.replace.template.xsl"/>
	<xsl:template match="blog">
		<script type="text/javascript">
			<![CDATA[
			function toggle(layername)
			{
				elm = document.getElementById(layername);
				if(elm.style.visibility == 'visible') hide(layername);
				else show(layername);
			}
			function show(layername)
			{
				elm = document.getElementById(layername);
				elm.style.visibility='visible';
				elm.style.display="block";
			}
			function hide(layername)
			{
				elm = document.getElementById(layername);
				elm.style.visibility='hidden';
				elm.style.display="none";
			}
			]]>
		</script>
		<div class="blog">
			<div class="blog_command">
				<xsl:element name="a">
					<xsl:attribute name="href"><xsl:value-of select="module-call-info/application-id" />/<xsl:value-of select="@pagename"/>?render=rss</xsl:attribute>
					<xsl:attribute name="target">_new</xsl:attribute>
					rss
				</xsl:element>
				<xsl:if test="/page/session/item[@key='is_auth']/@value='1'">
					|
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="module-call-info/application-id" />?action=create</xsl:attribute>
						new
					</xsl:element>
					|
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="module-call-info/application-id" />?action=admin</xsl:attribute>
						admin
					</xsl:element>
					|
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="module-call-info/application-id" />?category=__drafts</xsl:attribute>
						drafts
					</xsl:element>
				</xsl:if>
				<xsl:if test="not(/page/session/item[@key='is_auth']/@value='1')">
					|
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="module-call-info/application-id" />?action=auth_form</xsl:attribute>
						auth
					</xsl:element>
				</xsl:if>
			</div>
			<div class="blog_action_box">
				<xsl:apply-templates select="../blog/action"/>
			</div>
			<div class="blog_side_bar">
				<div class="blog_banner">
					<img src="{/page/request/base-uri}/../themes/default/crowbanner.jpg"/>
				</div>
				<div class="blog_calendar">
						<xsl:apply-templates select="calendar"/>
				</div>
				<div class="blog_categories">
					<div class="blog_categories_title">Categories</div>
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="module-call-info/application-id" /><xsl:value-of select="@key"/></xsl:attribute>
						All
					</xsl:element>
					<br/>
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="module-call-info/application-id" /><xsl:value-of select="@key"/>?category=__starred</xsl:attribute>
						 Starred
					</xsl:element>
					<font size="1"><a href="{module-call-info/application-id}?category=__starred&amp;render=rss" target="_new">rss</a></font>
					<xsl:text> </xsl:text>
					<font size="1"><a href="{module-call-info/application-id}?category=__starred&amp;title_only=yes">all</a></font>
					<br/>
					<xsl:for-each select="../blog/categories/category">
						<xsl:element name="a">
							<xsl:attribute name="href"><xsl:value-of select="../../module-call-info/application-id" />?category=<xsl:value-of select="@key"/></xsl:attribute>
							<xsl:value-of select="name"/>
						</xsl:element>
						<xsl:text> </xsl:text>
						<font size="1"><a href="{../../module-call-info/application-id}?category={@key}&amp;render=rss" target="_new">rss</a></font>
						<xsl:text> </xsl:text>
						<font size="1"><a href="{../../module-call-info/application-id}?category={@key}&amp;title_only=yes">all</a></font>
						<br/>
					</xsl:for-each>
				</div>
				<div class ="blog_recent_replies">
					<div class="blog_recent_replies_title">Recent Replies</div>
					<xsl:for-each select="../blog/recent-replies/recent-reply">
						<xsl:element name="a">
							<xsl:attribute name="href"><xsl:value-of select="../../module-call-info/application-id" />/<xsl:value-of select="@posting-id"/></xsl:attribute>
							<xsl:value-of select="substring(.,0,16)"/>..
						</xsl:element><br/>
					</xsl:for-each>
				</div>
				<div class="blog_monthly_archives">
						<xsl:apply-templates select="monthly-archives"/>
				</div>
			</div>
		</div>
	</xsl:template>
	<xsl:template match="monthly-archives">
		<div class="blog_monthly_archive_title">
			Monthly Archives
		</div>
		<div class="blog_monthly_archive_data">
			<xsl:for-each select="monthly-archive">
				<div class="blog_monthly_archive">
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="../../module-call-info/application-id" />?month=<xsl:value-of select="@id"/>&amp;title_only=yes</xsl:attribute>
						<xsl:value-of select="@id"/>
					</xsl:element><br/>
				</div>
			</xsl:for-each>
		</div>		
	</xsl:template>
	<xsl:template match="calendar">
		<div class="blog_calendar_title">
			Calendar : <xsl:value-of select="@linkyear"/>/<xsl:value-of select="@linkmonth"/>
		</div>
		<div class="blog_calendar_data">
			<div class="blog_calendar_week">
				<xsl:for-each select="week">
					<xsl:for-each select="day">
						<xsl:if test="@noday='yes'">
							<div class="blog_calendar_noday"/>
						</xsl:if>
						<xsl:if test="@noday='no'">
							<xsl:if test="@weekday='Sun'">
								<xsl:if test="@postings='yes'">
									<div class="blog_calendar_posting_day">
										<xsl:element name="a">
											<xsl:attribute name="href"><xsl:value-of select="/page/request/base-uri"/>/<xsl:value-of select="/page/@application-id" />?day=<xsl:value-of select="../../@linkyear"/><xsl:value-of select="../../@linkmonth"/><xsl:value-of select="@linkday"/>&amp;title_only=yes</xsl:attribute>
											<xsl:value-of select="@num"/>
										</xsl:element>

									</div>
								</xsl:if>
								<xsl:if test="@postings='no'">
									<div class="blog_calendar_sunday"><xsl:value-of select="@num"/></div>
								</xsl:if>
								
							</xsl:if>
							<xsl:if test="not(@weekday='Sun')">
								<xsl:if test="@postings='yes'">
									<div class="blog_calendar_posting_day">
										<xsl:element name="a">
											<xsl:attribute name="href"><xsl:value-of select="/page/request/base-uri"/>/<xsl:value-of select="/page/@application-id" />?day=<xsl:value-of select="../../@linkyear"/><xsl:value-of select="../../@linkmonth"/><xsl:value-of select="@linkday"/>&amp;title_only=yes</xsl:attribute>
											<xsl:value-of select="@num"/>
										</xsl:element>
									</div>
								</xsl:if>
								<xsl:if test="@postings='no'">
									<div class="blog_calendar_day"><xsl:value-of select="@num"/></div>
								</xsl:if>
								
							</xsl:if>
							
						</xsl:if>
						
					</xsl:for-each>
					<br/>
				</xsl:for-each>
			</div>
		</div>		
	</xsl:template>
	<xsl:template match="trackbacks">
			<div class="blog_trackback_info">
				posting uri:<br/>
				<xsl:value-of select="/page/request/base-uri"/>/<xsl:value-of select="/page/@application-id" />/<xsl:value-of select="../@id"/>
				<br/>
				trackback uri:<br/>
				<xsl:value-of select="/page/request/base-uri"/>/<xsl:value-of select="/page/@application-id" />/<xsl:value-of select="../@id"/>?action=trackback
			</div>
			
			<xsl:apply-templates select="trackback"/>
	</xsl:template>

	<xsl:template match="trackback">
		<div class="blog_a_trackback">

			<div class="blog_a_trackback_url">
				<xsl:element name="a">
					<xsl:attribute name="target">_new</xsl:attribute>
					<xsl:attribute name="href"><xsl:value-of select="url"/></xsl:attribute>
					<xsl:value-of select="title"/> (from <xsl:value-of select="blog_name"/>)
				</xsl:element>
			</div>

			<xsl:if test="/page/session/item[@key='is_auth']/@value='1'">
				<div class="blog_a_trackback_delete_command">
				<xsl:element name="a">
					<xsl:attribute name="href"><xsl:value-of select="/page/@application-id" />/<xsl:value-of select="../../@id"/>?action=delete_trackback&amp;trackback_seq=<xsl:value-of select="@seq"/></xsl:attribute>
					x
				</xsl:element>
				</div>
			</xsl:if>

			<div class="blog_a_trackback_excerpt">
				<xsl:value-of select="substring(excerpt,0,100)"/>
			</div>
		</div>
	</xsl:template>

	<xsl:template match="replies">
			<xsl:apply-templates select="reply"/>
			<div class="blog_reply_form">			
				<form name="reply_form" method="POST">
					name : <input name="writer_name" type="text" size="10"/>
					password : <input name="passwd" type="password" size="10"/><br/>
					url : <input name="writer_contact" type="text" size="40" value="None"/>
					<textarea name="content" style="width:550"/><br/>

					<input type="hidden" name="action" value="make_reply"/>
					<xsl:element name="input">
						<xsl:attribute name="type">hidden</xsl:attribute>
						<xsl:attribute name="value"><xsl:value-of select="../@id"/></xsl:attribute>
						<xsl:attribute name="name">posting_id</xsl:attribute>
					</xsl:element>
					<input type="submit" name="submit_button" value="OK"/>
				</form>
			</div>
	</xsl:template>
	
	<xsl:template match="reply">
		<div class="blog_a_reply">
			<div class="blog_a_reply_writer_name">
				<xsl:if test="writer/contact != 'None'">
					<a href="{writer/contact}"><xsl:value-of select="writer/name"/></a>(<xsl:value-of select="writer/contact"/>)
				</xsl:if>
				<xsl:if test="writer/contact = 'None'">
					<xsl:value-of select="writer/name"/>
				</xsl:if>
			</div>
			<div class="blog_a_reply_created_time">
				<xsl:value-of select="created_time"/>
			</div>
			<xsl:if test="/page/session/item[@key='is_auth']/@value='1'">
				<div class="blog_a_reply_delete_command">
				<xsl:element name="a">
					<xsl:attribute name="href"><xsl:value-of select="/page/@application-id" />/<xsl:value-of select="../../@id"/>?action=delete_reply&amp;reply_seq=<xsl:value-of select="@seq"/></xsl:attribute>
					x
				</xsl:element>
				</div>
			</xsl:if>
			<xsl:if test="not(/page/session/item[@key='is_auth']/@value='1')">

				<div class="blog_a_reply_delete_command">
					<xsl:element name="a">
					<xsl:attribute name="href">javascript:toggle('blog_reply_delete_form_<xsl:value-of select="../../@id"/>_<xsl:value-of select="@seq"/>');</xsl:attribute>
						x
					</xsl:element>
				</div>
			</xsl:if>
			<div class="blog_a_reply_content">
				<xsl:call-template name="str:replace">
					<xsl:with-param name="string" select="content"/>
					<xsl:with-param name="search" select="'&#x0A;'"/>
					<xsl:with-param name="replace"><br/></xsl:with-param>
				</xsl:call-template>
				<!--<xsl:value-of select='translate(string(content),"&#x0A;","&lt;br/&gt;")'/>-->
				<!--<xsl:value-of select="translate(text(content),' ','&lt;br/&gt;')"/>
				<xsl:analyze-string select="content" regex="\n">
					<xsl:non-matching-substring>
						<xsl:value-of select="."/>
					</xsl:non-matching-substring>
					<xsl:matching-substring>
						<br/>
					</xsl:matching-substring>
				</xsl:analyze-string>-->
			</div>

			<xsl:if test="not(/page/session/item[@key='is_auth']/@value='1')">
				<div id="blog_reply_delete_form_{../../@id}_{@seq}" class="blog_a_reply_delete_form">
					<form method="GET" action="{/page/@application-id}/{../../@id}">
						password : <input type="password" name="password"/>
						<input type="submit" value="delete"/>
						<input type="hidden" name="action" value="delete_reply"/>
						<input type="hidden" name="reply_seq" value="{@seq}"/>
					</form>
				</div>
			</xsl:if>

		</div>
	</xsl:template>
	
	<xsl:template match="blog/action[@name='error']">
		<div class="error_box">
		Error OCCURED in Blog Processing <br/>
		<xsl:value-of select="."/>
		</div>
	</xsl:template>

	<xsl:template match="blog/action[@name='auth_form']">
		<div class="blog_auth_form">
			<form method="POST">
				<input type="hidden" name="action" value="auth_form"/>
				<input type="password" name="auth_password" value=""/>
				<input type="submit" value="Login"/>
			</form>
		</div>
	</xsl:template>

	<xsl:template match="blog/action[@name='send_ping_form']">
		<div class="blog_send_ping_form">
			<form method="POST">
				<table>
					<input type="hidden" name="action" value="send_ping"/>
					<tr><td>target uri : </td><td><input type="text" style="width:400px" name="target_uri" value=""/></td></tr>
					<tr><td>local uri : </td><td><input type="text" style="width:400px" name="local_uri" value="{/page/request/base-uri}/{/page/@application-id}/{./posting/@id}"/></td></tr>
					<tr><td>site name : </td><td><input type="text" style="width:400px" name="site_name" value="{/page/site-info/site-name}"/></td></tr>
					<tr><td>title : </td><td><input type="text" style="width:400px" name="title" value="{./posting/title}"/></td></tr>
				</table>
				ping content  : <br/><textarea style="width:500px;height:500px" type="text" name="content"><xsl:value-of select="substring(./posting/content,0,100)"/></textarea><br/>
				<input type="submit" value="Send"/>
			</form>
		</div>
	</xsl:template>

	<xsl:template match="blog/action[@name='admin']">
		<div class="blog_admin">
			<form method="POST">
				<input type="hidden" name="action" value="admin"/>
				<input type="hidden" name="admin_action" value="create_category"/>
				<input type="submit" value="create"/>
			</form>
			Category Lists.<br/>
			<xsl:for-each select="../categories/category">
				<xsl:if test='not(@key="__uncategoried")'>
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="../../module-call-info/application-id" />?category=<xsl:value-of select="@key"/></xsl:attribute>
						<xsl:attribute name="target">_new</xsl:attribute>
						<xsl:value-of select="name"/>
					</xsl:element>
					<xsl:text> </xsl:text>
					<font size="1"><a href="{../../module-call-info/application-id}?action=admin&amp;admin_action=edit_category&amp;category={@key}">edit</a></font>
					<xsl:text> </xsl:text>
					<font size="1"><a href="{../../module-call-info/application-id}?action=admin&amp;admin_action=delete_category&amp;category={@key}">delete</a></font>
					<br/>
				</xsl:if>
			</xsl:for-each>
			<xsl:if test="@admin_action='edit_category'">
				<xsl:variable name="category_key"><xsl:value-of select="category-to-edit/@key"/></xsl:variable>
				edit <xsl:value-of select="category-to-edit/@key"/><br/>
				<form method="POST">
					<input type="hidden" name="action" value="admin"/>
					<input type="hidden" name="admin_action" value="edit_category_db"/>
					<input type="hidden" name="category_key" value="{category-to-edit/@key}"/>
					name : <input type="text" name="category_name" value="{../categories/category[@key=$category_key]/name}"/><br/>
					desc : <input type="text" name="category_desc" value="{../categories/category[@key=$category_key]/desc}"/><br/>
					<input type="submit" value="save"/>
				</form>
			</xsl:if>
			<xsl:if test="@admin_action='edit_category_db'">
				<script type="text/javascript">
					<![CDATA[
					location.href = document.referrer;
					]]>
				</script>
			</xsl:if>
			<xsl:if test="@admin_action='create_category'">
				<form method="POST">
					<input type="hidden" name="action" value="admin"/>
					<input type="hidden" name="admin_action" value="create_category_db"/>
					key : <input type="text" name="category_key" value=""/>
					name : <input type="text" name="category_name" value=""/><br/>
					desc : <input type="text" name="category_desc" value=""/><br/>
					<input type="submit" value="save"/>
				</form>
			</xsl:if>
			<xsl:if test="@admin_action='create_category_db'">
				<script type="text/javascript">
					<![CDATA[
					location.href = document.referrer;
					]]>
				</script>
			</xsl:if>
			<xsl:if test="@admin_action='delete_category'">
				<xsl:variable name="category_key"><xsl:value-of select="category-to-edit/@key"/></xsl:variable>
				deleting category <xsl:value-of select="category-to-edit/@key"/><br/>
				Every post in category <xsl:value-of select="category-to-edit/@key"/> will be moved to Uncategoried. <br/>
				<form method="POST">
					<input type="hidden" name="action" value="admin"/>
					<input type="hidden" name="admin_action" value="delete_category_db"/>
					<input type="hidden" name="category_key" value="{category-to-delete/@key}"/>
					<input type="submit" value="delete"/>
				</form>
			</xsl:if>
			<xsl:if test="@admin_action='delete_category_db'">
				<a href="{../module-call-info/application-id}?action=admin">delete ok</a>
			</xsl:if>
		</div>
	</xsl:template>

	<xsl:template match="blog/action[@name='view']">
		<div class="blog_posting">
			<div class="blog_posting_title">
				<xsl:value-of select="posting/title"/>
			</div>
			<div class="blog_posting_category_name">
				<xsl:variable name="category_key"><xsl:value-of select="posting/category/@key"/></xsl:variable>
				<xsl:value-of select="../categories/category[@key=$category_key]/name"/>
			</div>
			<div class="blog_posting_time">
				<xsl:value-of select="posting/created_time"/>
			</div>
			<div class="blog_posting_content">
				<xsl:value-of select="posting/content" disable-output-escaping="yes"/>
			</div>
			<div class="blog_posting_command">
				<xsl:if test="/page/session/item[@key='is_auth']/@value='1'">
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />/<xsl:value-of select="posting/@id"/>?action=send_ping_form</xsl:attribute>
						send ping
					</xsl:element>
					|
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />/<xsl:value-of select="posting/@id"/>?action=edit</xsl:attribute>
						edit
					</xsl:element>
					|
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />/<xsl:value-of select="posting/@id"/>?action=delete</xsl:attribute>
						delete
					</xsl:element>
					|
				</xsl:if>
				<xsl:element name="a">
					<xsl:attribute name="href">javascript:toggle('blog_trackbacks_<xsl:value-of select="posting/@id"/>');</xsl:attribute>
					trackback(<xsl:value-of select="count(posting/trackbacks/trackback)"/>)
				</xsl:element>
				|
				<xsl:element name="a">
					<xsl:attribute name="href">javascript:toggle('blog_replies_<xsl:value-of select="posting/@id"/>');</xsl:attribute>
					reply(<xsl:value-of select="count(posting/replies/reply)"/>)
				</xsl:element>
			</div>
			<xsl:element name="div">
				<xsl:attribute name="class">blog_trackbacks_show</xsl:attribute>
				<xsl:attribute name="id">blog_trackbacks_<xsl:value-of select="posting/@id"/></xsl:attribute>
				<xsl:apply-templates select="posting/trackbacks"/>
			</xsl:element>
			<br/>
			<xsl:element name="div">
				<xsl:attribute name="class">blog_replies_show</xsl:attribute>
				<xsl:attribute name="id">blog_replies_<xsl:value-of select="posting/@id"/></xsl:attribute>
				<xsl:apply-templates select="posting/replies"/>
			</xsl:element>
			<br/>
		</div>
	</xsl:template>

	<xsl:template match="blog/action[@name='list']">
		<xsl:for-each select="posting-list/posting">
			<div class="blog_posting">
				<div class="blog_posting_title">
					<xsl:value-of select="title"/>
				</div>
				<div class="blog_posting_category_name">
					<xsl:variable name="category_key"><xsl:value-of select="category/@key"/></xsl:variable>
					<xsl:value-of select="../../../categories/category[@key=$category_key]/name"/>
				</div>
				<div class="blog_posting_time">
					<xsl:value-of select="created_time"/>
				</div>
				<div class="blog_posting_content">
					<xsl:value-of select="content" disable-output-escaping="yes"/>
				</div>
				
				<div class="blog_posting_command">
					<xsl:if test="/page/session/item[@key='is_auth']/@value='1'">
						<xsl:element name="a">
							<xsl:attribute name="href"><xsl:value-of select="../../../module-call-info/application-id" />/<xsl:value-of select="@id"/>?action=send_ping_form</xsl:attribute>
							send ping
						</xsl:element>
						|
						<xsl:element name="a">
							<xsl:attribute name="href"><xsl:value-of select="../../../module-call-info/application-id" />/<xsl:value-of select="@id"/>?action=edit</xsl:attribute>
							edit
						</xsl:element>
						|
						<xsl:element name="a">
							<xsl:attribute name="href"><xsl:value-of select="../../../module-call-info/application-id" />/<xsl:value-of select="@id"/>?action=delete</xsl:attribute>
							delete
						</xsl:element>
						|
					</xsl:if>
					<xsl:element name="a">
						<xsl:attribute name="href">javascript:toggle('blog_trackbacks_<xsl:value-of select="@id"/>');</xsl:attribute>
						trackback(<xsl:value-of select="count(trackbacks/trackback)"/>)
					</xsl:element>
					|
					<xsl:element name="a">
						<xsl:attribute name="href">javascript:toggle('blog_replies_<xsl:value-of select="@id"/>');</xsl:attribute>
						reply(<xsl:value-of select="count(replies/reply)"/>)
					</xsl:element>
				</div>
				<xsl:element name="div">
					<xsl:attribute name="class">blog_trackbacks</xsl:attribute>
					<xsl:attribute name="id">blog_trackbacks_<xsl:value-of select="@id"/></xsl:attribute>
					<xsl:apply-templates select="trackbacks"/>
				</xsl:element>
				<br/>
				<xsl:element name="div">
					<xsl:attribute name="class">blog_replies</xsl:attribute>
					<xsl:attribute name="id">blog_replies_<xsl:value-of select="@id"/></xsl:attribute>
					<xsl:apply-templates select="replies"/>
				</xsl:element>
				<br/>
			</div>
		</xsl:for-each>
		<!-- Page Processing-->
		<p align="center">
		<xsl:if test="not(../page/@prev_page='-1')">
			<xsl:element name="a">
				<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />?category=<xsl:value-of select="category-name/@key"/>&amp;page=<xsl:value-of select="../page/@prev_page"/></xsl:attribute>
				prev
			</xsl:element>
		</xsl:if>
		<xsl:if test="not(../page/@next_page='-1')">
			<xsl:element name="a">
				<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />?category=<xsl:value-of select="category-name/@key"/>&amp;page=<xsl:value-of select="../page/@next_page"/></xsl:attribute>
				next
			</xsl:element>
		</xsl:if>
		</p>
	</xsl:template>

	<xsl:template match="blog/action[@name='list_title_only']">
		<xsl:for-each select="posting-list/posting">
			<div class="blog_posting_title_only">
				<div class="blog_posting_title">
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="../../../module-call-info/application-id" />/<xsl:value-of select="@id"/></xsl:attribute>
						<xsl:value-of select="title"/>
					</xsl:element>
				</div>
				<div class="blog_posting_category_name">
					<xsl:variable name="category_key"><xsl:value-of select="category/@key"/></xsl:variable>
					<xsl:value-of select="../../../categories/category[@key=$category_key]/name"/>
				</div>
				<div class="blog_posting_time">
					<xsl:value-of select="created_time"/>
				</div>
			</div>
		</xsl:for-each>
	</xsl:template>

	
	<xsl:template match="blog/action[@name='delete']">
		<script type="text/javascript">
			<![CDATA[
			]]>
		</script>
		Delete Successed <br/>
		<xsl:value-of select="."/>
	</xsl:template>
	<xsl:template match="blog/action[@name='make_reply']">
		<script type="text/javascript">
			<![CDATA[
			location.href = document.referrer;
			]]>
		</script>
		You have left a reply!!! Move to 
		<xsl:element name="a">
			<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />/<xsl:value-of select="@posting-id"/></xsl:attribute>
			appropriate posting.
		</xsl:element>
		<br/>
		<xsl:value-of select="."/>
	</xsl:template>
	<xsl:template match="blog/action[@name='delete_reply']">
		<script type="text/javascript">
			<![CDATA[
			location.href = document.referrer;
			]]>
		</script>
		You have deleted a reply!!! Move to 
		<xsl:element name="a">
			<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />/<xsl:value-of select="@posting-id"/></xsl:attribute>
			appropriate posting.
		</xsl:element>
		<br/>
		<xsl:value-of select="."/>
	</xsl:template>
	<xsl:template match="blog/action[@name='delete_trackback']">
		<script type="text/javascript">
			<![CDATA[
			location.href = document.referrer;
			]]>
		</script>
		You have deleted a trackback!!! Move to 
		<xsl:element name="a">
			<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />/<xsl:value-of select="@posting-id"/></xsl:attribute>
			appropriate posting.
		</xsl:element>
		<br/>
		<xsl:value-of select="."/>
	</xsl:template>
	<xsl:template match="blog/action[@name='create_db']">
		<script type="text/javascript">
			<![CDATA[
			]]>
		</script>
		You have created a posting!!! Move to 
		<xsl:element name="a">
			<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />/<xsl:value-of select="@posting-id"/></xsl:attribute>
			created posting.
		</xsl:element>
		<br/>
		<xsl:value-of select="."/>
	</xsl:template>

	<xsl:template match="blog/action[@name='create']">
		<div class="blog_create">
			<form name="create_form" method="POST">
				TITLE: <input type="text" name="title" style="width:100%"/>
				<select name="category">
					<option value="__drafts">Drafts</option>
					<xsl:for-each select="../categories/category">
						<xsl:element name="option">
							<xsl:attribute name="value"><xsl:value-of select="@key"/></xsl:attribute>
							<xsl:value-of select="name"/>
						</xsl:element>
					</xsl:for-each>
				</select>
				Is Starred? <input type="checkbox" name="is_starred"/>
				<input type="hidden" name="action" value="create_db"/>
				<br/>
				<textarea style="height:500;width:100%" id="content" name="content"><xsl:value-of select="page-data"/></textarea>
				<br/>
				<script type="text/javascript">
					<![CDATA[
					tinyMCE.init(
						{
						mode:"exact",
						elements:"content",
						theme:"advanced",
						theme_advanced_toolbar_location:"top",
						content_css:"../themes/default/default.css"
						}
					);
					]]>
				</script>
				track to : <input type="text" name="trackback_uri" style="width:100%"/><br/>
				<input type="submit" name="submit_button" value="OK"/>
				</form>
		</div>
	</xsl:template>

	<xsl:template match="blog/action[@name='edit_db']">
		<script type="text/javascript">
			<![CDATA[
			]]>
		</script>
		You have edited a posting!!! Move to 
		<xsl:element name="a">
			<xsl:attribute name="href"><xsl:value-of select="../module-call-info/application-id" />/<xsl:value-of select="@posting-id"/></xsl:attribute>
			edited posting.
		</xsl:element>
		<br/>
	</xsl:template>

	<xsl:template match="blog/action[@name='edit']">
		<div class="blog_create">
			<form name="create_form" method="POST">
				TITLE: 
				<xsl:element name="input">
					<xsl:attribute name="type">text</xsl:attribute>
					<xsl:attribute name="name">title</xsl:attribute>
					<xsl:attribute name="style">width:100%</xsl:attribute>
					<xsl:attribute name="value"><xsl:value-of select="posting/title"/></xsl:attribute>
				</xsl:element>
				<select name="category">
					<option value="__drafts">Drafts</option>
					<xsl:for-each select="../categories/category">
						<xsl:element name="option">
							<xsl:attribute name="value"><xsl:value-of select="@key"/></xsl:attribute>
							<xsl:if test="../../action/posting/category/@key=@key">
								<xsl:attribute name="selected">true</xsl:attribute>
							</xsl:if>
							<xsl:value-of select="name"/>
						</xsl:element>
					</xsl:for-each>
				</select>
				<xsl:element name="input">
					<xsl:attribute name="type">hidden</xsl:attribute>
					<xsl:attribute name="name">old_category_key</xsl:attribute>
					<xsl:attribute name="value"><xsl:value-of select="posting/category/@key"/></xsl:attribute>
				</xsl:element>
				<input type="hidden" name="action" value="edit_db"/>
				Is Starred? <input type="checkbox" name="is_starred"/>
				<textarea style="height:500;width:100%" id="content" name="content"><xsl:value-of select="posting/content"/></textarea>
				<br/>
				<script type="text/javascript">
					<![CDATA[
					tinyMCE.init(
						{
						mode:"exact",
						elements:"content",
						theme:"advanced",
						theme_advanced_toolbar_location:"top",
						content_css:"../../themes/default/default.css",
						script_url_base:"../../tiny_mce"
						}
					);
					]]>
				</script>
				<br/>
				<input type="submit" name="submit_button" value="OK"/>
				</form>
		</div>
	</xsl:template>
</xsl:stylesheet>
