_q_exports = ["statics" , "themes"]

import Queue
import MySQLdb

import commonutil

connection_queue = Queue.Queue()

def create_connection():
	conn = MySQLdb.connect(user="crowmania", passwd="rkakr", db="crowmania", unicode="euckr")
	conn.cursor().execute("SET CHARSET euckr")
	conn.autocommit(True)
	return conn

connection_queue.put(create_connection())

class Filter:
	def __init__(self, namespace, name):
		exec "from %s import %s" % (namespace, name)
		self.filter = None
		exec "self.filter = %s" % (name)

class RecursivePath:
	_q_exports = []
	def __init__(self, name):
		self.name = name
	def _q_index(self, req):
		return self.process(req)
	def _q_lookup(self, request, component): 
		return self
	def __call__(self, request):
		return self.process(request)
	def process(self, request):
		return "by req path: " + request.get_path() + " name = " + self.name	

class QuerySet:
	def __init__(self, name):
		self.queries = []
		self.name = name
		self.redirection = None
	def add_query_template(self, query):
		self.queries.append(query)
	
	def set_redirection(self, href):
		self.redirection = href
	
	def execute(self, match_dict):
		if len(self.queries) == 0:
			import rsxml
			return rsxml.ResultDescriber().render_empty()
		else:
			to_ret = ""
			for query in self.queries:
				to_ret += query.execute(match_dict)
			return to_ret
	
class Query(QuerySet):
	def __init__(self, query_name, query_template, parent=None):
		QuerySet.__init__(self, query_name)
		self.name = query_name
		self.template = query_template
		self.parent = parent
		self.defaults = {}
		self.last_row_dict = {}
		self.post_filters = []
		self.pre_filters = []
	
	def bind_default(self, key, value):
		self.defaults[key] = value
	
	def get_result_value(self, name):
		if self.last_row_dict.has_key(name):
			return self.last_row_dict[name]
		return None
	
	def execute(self, given_match_dict):

		# process default value
		match_dict = given_match_dict
		for key,value in self.defaults.items():
			if not match_dict.has_key(key):
				match_dict[key] = value

		made_query = self.make_query(match_dict)
		
		import exceptions		
		conn = connection_queue.get()
		rs = None
		import rsxml
		
		desc = ""
		renderer = rsxml.ResultDescriber()
		
		try:
			db_cursor = conn.cursor()
			#db_cursor.execute("SET CHARSET euckr")
			db_cursor.execute(made_query.decode("utf-8").encode("euc-kr"))
			rs = db_cursor.fetchall()
			desc = db_cursor.description
			connection_queue.put(conn)
		except exceptions.Exception, error_inst:
			try:
				conn.close()
				connection_queue.put(create_connection())
			except exceptions.Exception, conn_error_inst:
				return renderer.render_error(str(conn_error_inst))
			else:
				return renderer.render_error("Execution Error Occured:: %s \r\n query " % (str(error_inst),made_query))
		
		renderer.start_result(self.name, made_query)

		for row in rs:
			renderer.start_row()
			
			escape = True
			
			# before process sub queries execute post filters (QueryResultFilter)
			for filter in self.post_filters:
				desc, row, escape_flag = filter.filter(desc, row)
				if escape_flag == False:
					escape = False
			
			self.update_last_row_dict(row, desc)
			
			col_idx = 0
			for col in row:
				renderer.start_column(desc[col_idx][0], col, escape)
				renderer.end_column()
				col_idx += 1
			
			for query in self.queries:
				renderer.add_nest_result(query.execute(match_dict))
			
			renderer.end_row()
		
		renderer.end_result()
		
		return renderer.get_result()

	def make_query(self, match_dict):
		made_query = self.template

		# basic form matching
		positions = []
		for key in match_dict.keys():
			expression = "%("+key+")"
			pos = made_query.find(expression)
			if pos > 0:
				type_str = made_query[pos+len(expression)]
				if type_str == "d":
					made_query = "%s%d%s" % \
						(made_query[0:pos], int(match_dict[key]), \
						 made_query[pos+len(expression)+1:])
				elif type_str == "s":
					made_query = "%s'%s'%s" % \
						(made_query[0:pos],\
						 match_dict[key], \
						 made_query[pos+len(expression)+1:])
		
		# parent matching
		if self.parent != None:
			while True:
				pos1 = made_query.find("%(parent:")
				if pos1 < 0:
					break
				else:
					key = made_query[pos1+9:]
					pos2 = key.find(")")
					
					if pos2 < 0:
						break
					type_str = key[pos2+1]
					key = key[0:pos2]
					if type_str == "d":
						made_query = "%s%d%s" % \
							(made_query[0:pos1],int(self.parent.get_result_value(key)),made_query[pos1+9+pos2+2:])
					elif type_str == "s":
						made_query = "%s'%s'%s" % \
							(made_query[0:pos1],self.parent.get_result_value(key),made_query[pos1+9+pos2+2:])					
		return made_query
	
	def update_last_row_dict(self, row, desc):
		self.last_row_dict.clear()
		col_idx = 0
		for column in row:
			self.last_row_dict[desc[col_idx][0]] = column
			col_idx += 1
		

class XSLTForm:
	def __init__(self, name):
		self.name = name
	def execute(self):
		return """<XSLTForm name="%s"/>""" % (self.name)


class SQLApplication(RecursivePath):
	def __init__(self, name, default_query):
		RecursivePath.__init__(self, name)
		self.default_query = default_query
		self.query_sets = {}
		self.xslt_forms = {}

	def add_query_set(self, query_name, query_set):
		self.query_sets[query_name] = query_set
	
	def process(self, request):
		if request.session == None:
			print "session didn't created"
		else:
			if not request.session.session_dict.has_key("SQLAPPPROCCOUNT"):
				request.session.session_dict["SQLAPPPROCCOUNT"] = 1	
			else:
				request.session.session_dict["SQLAPPPROCCOUNT"] += 1
			
		path_list = request.get_path().split("/")
		if len(path_list) > 2:
			query_name = request.get_path().split("/")[2]
		else:
			#if there is no defined default query, make error
			query_name = self.default_query
		
		if self.xslt_forms.has_key(query_name):
			return """<?xml version="1.0" encoding="utf-8"?><Application id="%s"  action="%s">%s%s%s</Application>""" % (self.name, query_name, commonutil.convert_dict(request.form,"Request"), commonutil.convert_dict(request.session.session_dict,"Session"), self.xslt_forms[query_name].execute())
		
		if not self.query_sets.has_key(query_name):
			return "there is no query like " + query_name
		
		result = """<?xml version="1.0" encoding="utf-8"?><Application id="%s" action="%s">%s%s%s</Application>""" % (self.name, query_name, commonutil.convert_dict(request.form,"Request"),commonutil.convert_dict(request.session.session_dict,"Session"), self.query_sets[query_name].execute(request.form))
		
		if self.query_sets[query_name].redirection != None:
			return request.redirect(self.query_sets[query_name].redirection)
		
		if request.form.has_key("xslt") and request.form["xslt"] == "no":
			request.response.set_content_type("text/xml; utf-8")
			return result
		else:
			import libxml2
			import libxslt
			request.response.set_content_type("text/html")
			style = libxslt.parseStylesheetFile("themes/default/main.xsl")
			doc = libxml2.parseMemory(result, len(result))
			result_dom = style.applyStylesheet(doc, None)
			toRet = style.saveResultToString(result_dom)
			style.freeStylesheet()
			doc.freeDoc()
			result_dom.freeDoc()
			return toRet
		#return .encode("utf-8")
		#return result
	
		

from libxml2 import parseFile

class ApplicationConfig:
	def __init__(self, application_xml_path):
		self.dom = parseFile(application_xml_path)
		self.applications = []
		ctx = self.dom.xpathNewContext()
		res = ctx.xpathEval("//SQLApplication")
						
		for app_element in res:
			if app_element.hasProp("name") and app_element.hasProp("default"):
				app = SQLApplication(app_element.prop("name"), app_element.prop("default"))
				self.load_query_set(app_element, app)
				for form_element in app_element.xpathEval("./XSLTForm"):
					app.xslt_forms[form_element.prop("name")] = XSLTForm(form_element.prop("name"))
		   		self.applications.append(app)
		   	
		
	def load_query_set(self, app_element, app):
		#print dir(app_element)
		res = app_element.xpathEval("./QuerySet")
		
		for query_set_element in res:
			if query_set_element.hasProp("name"):
				query_set = QuerySet(query_set_element.prop("name"))
				res2 = query_set_element.xpathEval("./Query")
				for query_element in res2:
					if query_element.hasProp("link"):
						self.load_query_link(query_element, query_set)
					else:
						self.load_query(query_element, query_set)
				for redirection_element in query_set_element.xpathEval("./Redirection"):
					query_set.set_redirection(redirection_element.prop("href"))
				app.add_query_set(query_set_element.prop("name"), query_set)
	
	def load_query_link(self, query_element, query_set):
		ctx = self.dom.xpathNewContext()
		res = ctx.xpathEval("/SQLApplications/Queries/Query[@name='%s']" %(query_element.prop("link")))
		if len(res) > 0:
			#print "found link : " + query_element.prop("link")
			self.load_query(res[0],query_set)
		else:
			print "cannot find link : " + query_element.prop("link")
			
	def load_query(self, query_element, query_set):
		res = query_element.xpathEval("./Template")
		if len(res) > 0:
			query = Query(query_element.prop("name"), res[0].content, query_set)
			
			for default_element in query_element.xpathEval("./Default"):
				query.defaults[default_element.prop("name")] = default_element.content
			
			for filter_element in query_element.xpathEval("./QueryResultFilter"):
				query.post_filters.append(Filter(filter_element.prop("namespace"), filter_element.prop("name")))

			for filter_element in query_element.xpathEval("./QueryPreFilter"):
				query.pre_filters.append(Filter(filter_element.prop("namespace"), filter_element.prop("name")))
			
			query_set.add_query_template(query)
			subres = query_element.xpathEval("./Query")
			for subquery_element in subres:
				if subquery_element.hasProp("link"):
					self.load_query_link(subquery_element, query)
				else:
					self.load_query(subquery_element, query)
			

def load_config():
	print (os.path.dirname(__file__)+"\\applications.xml").replace("\\","/")
	return ApplicationConfig((os.path.dirname(__file__)+"\\applications.xml").replace("\\","/"))


def _q_index(request):
	return request.get_path() + " this is the index!!!"

# Get current directory
import os
curdir = os.path.dirname(__file__)

def _q_lookup(request, component):
	# authorization code!!!
	if request.session.session_dict.has_key("authenticated"):
		pass
	else:
		pass
	application_config = ApplicationConfig((curdir+"\\applications.xml").replace("\\","/"))
	for app in application_config.applications:
		if app.name == component:
			return app

from quixote.util import StaticDirectory

statics_dir = (curdir+"\\statics").replace("\\","/")
themes_dir = (curdir+"\\themes").replace("\\","/")
statics = StaticDirectory(statics_dir, list_directory=1)
themes = StaticDirectory(themes_dir, list_directory=0)

