<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	xmlns:str="http://exslt.org/strings"
	xmlns:widget="http://playaction.kldp.net/widget"
>
	<xsl:import href="str.replace.template.xsl"/>
	<xsl:import href="common.xsl"/>
	<xsl:import href="widget.xsl"/>
	<xsl:import href="blog_view.xsl"/>
	<xsl:import href="blog_create.xsl"/>
	<xsl:import href="blog_admin.xsl"/>
	<xsl:template match="SQLResult[@error='yes']">
		<xsl:value-of select="text()"/>
	</xsl:template>		
	<xsl:template match="Application[@id='blog']">
		<script type="text/javascript">
			<![CDATA[
			function toggle(layername)
			{
				elm = document.getElementById(layername);
				if(elm.style.visibility == 'visible') hide(layername);
				else show(layername);
			}
			function show(layername)
			{
				elm = document.getElementById(layername);
				elm.style.visibility='visible';
				elm.style.display="block";
			}
			function hide(layername)
			{
				elm = document.getElementById(layername);
				elm.style.visibility='hidden';
				elm.style.display="none";
			}
			]]>
		</script>
		<div class="blog">
			<div class="blog_box">
				<xsl:call-template name="widget:compile">
					<xsl:with-param name="source">
					<widget:tabs classprefix="blog_main">
						<widget:tab id="blog_main_read" name="read list">
							<xsl:apply-templates select="SQLResult[@error='yes']"/>
							<xsl:apply-templates select="SQLResult[@name='article']"/>
						</widget:tab>
						<widget:tab id="blog_main_login" name="login">
							login form here!!
						</widget:tab>
						<widget:tab id="blog_main_create" name="create">
							<xsl:call-template name="blog_create_form"/>
						</widget:tab>
						<widget:tab id="blog_main_admin" name="admin">
							<xsl:call-template name="blog_admin_form"/>
						</widget:tab>
					</widget:tabs>
					</xsl:with-param>
				</xsl:call-template>
				
			</div>
			<div class="blog_side_bar">
				<div class="blog_banner">
					<img src="/themes/default/crowbanner.jpg"/>
				</div>
				<div class="blog_monthly_archives">
						<xsl:apply-templates select="SQLResult[@name='monthlydigest']"/>
				</div>
			</div>
		</div>
	</xsl:template>
	<xsl:template match="SQLResult[@name='monthlydigest']">
		<div class="blog_monthly_archive_title">
			Monthly Archives
		</div>
		<div class="blog_monthly_archive_data">
			<xsl:for-each select="Row">
				<div class="blog_monthly_archive">
					<xsl:element name="a">
						<xsl:attribute name="href"><xsl:value-of select="Column[@name='year']" />?month=<xsl:value-of select="Column[@name='month']"/>&amp;title_only=yes</xsl:attribute>
						<xsl:value-of select="Column[@name='year']"/>/<xsl:value-of select="Column[@name='month']"/>
					</xsl:element><br/>
				</div>
			</xsl:for-each>
		</div>		
	</xsl:template>
</xsl:stylesheet>
