<?xml version="1.0" encoding="euc-kr"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	xmlns:str="http://exslt.org/strings"
	xmlns:widget="http://playaction.kldp.net/widget"
>
<xsl:import href="widget.xsl"/>
	
<xsl:template match="SQLResult[@name='article']">
	<xsl:for-each select="Row">
	<div class="blog_post">
		<div class="blog_post_titlebar">
				<span class="blog_post_title"><xsl:value-of select="Column[@name='post_title']"/></span>
		</div>
		<div >
			<table width="100%" border="0">
				<tr>
					<td>
						<span class="blog_post_labels">
							<xsl:for-each select="SQLResult[@name='labels']/Row">
								<xsl:value-of select="Column[@name='label_name']"/><xsl:if test="position()!=last()">, </xsl:if>
								
							</xsl:for-each>
						</span>
					</td>
					<td align="right"><span class="blog_post_time"><xsl:value-of select="Column[@name='post_created_time']"/></span></td>
				</tr>				
			</table>
		</div>
		<xsl:call-template name="widget:compile">
			<xsl:with-param name="source">
			<widget:tabs classprefix="blog_post">
				<widget:tab id="{Column[@name='post_id']}_view" name="view">
					<xsl:value-of select="Column[@name='post_content']" disable-output-escaping="yes"/>
					<hr/>
					<widget:hideswitch id="replywritebox_{Column[@name='post_id']}">write reply</widget:hideswitch>, 
					<widget:hideswitch id="replybox_{Column[@name='post_id']}">see replies</widget:hideswitch>
					<widget:hidebox class="replywritebox" id="replywritebox_{Column[@name='post_id']}" show="no">
						<form action="/blog/write_reply" method="POST">
							name: <input name="name"/><br/>
							contact: <input name="contact" value="http://"/><br/>
							<textarea name="content" style="height:100;width:100%"/>
							<input type="hidden" name="post_id" value="{Column[@name='post_id']}"/>
							<input type="password" name="password"/>
							<input type="submit" value="write"/>
						</form>
						write box
					</widget:hidebox>
					<widget:hidebox class="replybox" id="replybox_{Column[@name='post_id']}" show="no">
						hihi
					</widget:hidebox>
				</widget:tab>
				<widget:tab id="{Column[@name='post_id']}_trackbacks" name="trackbacks">
					trackback data
				</widget:tab>
				<widget:tab id="{Column[@name='post_id']}_information" name="information">
					created time: <xsl:value-of select="Column[@name='post_created_time']"/><br/>
					modified time: <xsl:value-of select="Column[@name='post_modified_time']"/><br/>
					information
				</widget:tab>
				<xsl:if test="true()">
					<widget:tab id="{Column[@name='post_id']}_modify" name="modify">
						<form action="/blog/assign_label" method="GET">
							<xsl:if test="count(SQLResult[@name='selectablelabels']/Row) > 0">
								<select name="labelid" style="width:300px">
									<xsl:for-each select="SQLResult[@name='selectablelabels']/Row">
										<option value="{Column[@name='label_id']}"><xsl:value-of select="Column[@name='label_name']"/></option>
									</xsl:for-each>
								</select>
								<input type="hidden" name="id" value="{Column[@name='post_id']}"/>
								<input value="assign this" type="submit" style="width:100px"/>
							</xsl:if>
						</form>
						<form action="/blog/detach_label" method="GET">
							<xsl:if test="count(SQLResult[@name='labels']/Row) > 0">
								<select name="labelid" style="width:300px">
									<xsl:for-each select="SQLResult[@name='labels']/Row">
										<option value="{Column[@name='label_id']}"><xsl:value-of select="Column[@name='label_name']"/></option>
									</xsl:for-each>
								</select>
								<input type="hidden" name="id" value="{Column[@name='post_id']}"/>
								<input value="detach this" type="submit" style="width:100px"/>
							</xsl:if>
						</form>
						<br/>
					</widget:tab>
				</xsl:if>
			</widget:tabs>
			</xsl:with-param>
		</xsl:call-template>
	</div>
	</xsl:for-each>

	<xsl:if test="/Application/@action='list'">
		<div class="blog_pageselector">
			<xsl:variable name="offset">
				<xsl:value-of select="Match/item[@key='offset']/@value"/>
			</xsl:variable>
			<xsl:variable name="perpage">
				<xsl:value-of select="Match/item[@key='perpage']/@value"/>
			</xsl:variable>
			<xsl:variable name="count">
				<xsl:value-of select="/Application/SQLResult[@name='count_articles']/Row[@seq='0']/Column[@seq='0']"/>			
			</xsl:variable>
			<xsl:if test="$count > $offset+$perpage">
				<a href="?offset={$offset+$perpage}">next</a>
			</xsl:if>
			<xsl:if test="$offset - $perpage >= 0">
				<a href="?offset={$offset - $perpage}">prev</a>
			</xsl:if>
		</div>
	</xsl:if>

</xsl:template>



</xsl:stylesheet>