<?xml version="1.0" encoding="euc-kr"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template name="makecalendar">
		<xsl:param name="year">2005</xsl:param>
		<xsl:param name="month">7</xsl:param>
		<xsl:choose>
			<xsl:when test="number($month)=2">
				<xsl:choose>
					<xsl:when test="number($year) mod 100 = 0">
						<xsl:variable name="day_in_a_month">28</xsl:variable>
					</xsl:when>
					<xsl:when test="number($year) mod 4 = 0">
						<xsl:variable name="day_in_a_month">29</xsl:variable>
					</xsl:when>
					<xsl:otherwise>
						<xsl:variable name="day_in_a_month">28</xsl:variable>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="number($month) mod 2 = 1 ">
				<xsl:choose>
					<xsl:when test="8 > number($month)">
						<xsl:variable name="day_in_a_month">31</xsl:variable>
					</xsl:when>
					<xsl:otherwise>
						<xsl:variable name="day_in_a_month">30</xsl:variable>
					</xsl:otherwise>
				</xsl:choose>				
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="number($month) >= 8 ">
						<xsl:variable name="day_in_a_month">31</xsl:variable>
					</xsl:when>
					<xsl:otherwise>
						<xsl:variable name="day_in_a_month">30</xsl:variable>
					</xsl:otherwise>
				</xsl:choose>				
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="makebox">
		<xsl:param name="title"/>
		<xsl:param name="data"/>
		<xsl:param name="css_prefix">default</xsl:param>
		<xsl:param name="id"/>
		
		<xsl:element name="div">
			<xsl:attribute name="class"><xsl:value-of select="$css_prefix"/>_box</xsl:attribute>
			<xsl:if test="not($id='')">
				<xsl:attribute name="id"><xsl:value-of select="$id"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="not($title='')">
				<xsl:element name="div">
					<xsl:attribute name="class"><xsl:value-of select="$css_prefix"/>_box_title</xsl:attribute>
					<xsl:copy-of select="$title"/>
				</xsl:element>
			</xsl:if>
			<xsl:element name="div">
				<xsl:attribute name="class"><xsl:value-of select="$css_prefix"/>_box_content</xsl:attribute>
				<xsl:copy-of select="$data"/>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	
	<xsl:template name="makebox2">
		<xsl:param name="title"/>
		<xsl:for-each select="$title/Row">
			Node Param!!!
		</xsl:for-each>
		<xsl:for-each select="Row">
			Node Param!!!
		</xsl:for-each>
	</xsl:template>

</xsl:stylesheet>