<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	xmlns:widget="http://playaction.kldp.net/widget"
	xmlns:exslt="http://exslt.org/common"
>
<xsl:output encoding="utf-8" method="html" indent="yes"/>

<xsl:template name="widget:compile">
	<xsl:param name="source"/>
	<xsl:apply-templates select="exslt:node-set($source)/widget:*"/>
</xsl:template>

<xsl:template match="widget:widgets">
	<html>
	<head>
		<link rel ="stylesheet" href="test.css" type="text/css"/>
		<script type="text/javascript" src="widget.js"/>
	</head>
	<body>
	<xsl:apply-templates select="widget:*"/>
	</body>
	</html>
</xsl:template>

<xsl:template match="widget:bypass">
	<xsl:copy-of select="."/>
</xsl:template>

<xsl:template match="widget:container">
	<xsl:element name="div">
		<xsl:attribute name="class">
			<xsl:value-of select="@class"/>
		</xsl:attribute>
		<xsl:attribute name="id">
			<xsl:value-of select="@id"/>
		</xsl:attribute>
		<xsl:apply-templates select="*"/>
	</xsl:element>
</xsl:template>

<xsl:template match="widget:hideswitch">
	<a href="javascript:toggle('{@id}')"><xsl:value-of select="."/></a>
</xsl:template>

<xsl:template match="widget:hidebox">
	<xsl:if test="@show='yes'">
		<div class="{@class}" id="{@id}">
			<xsl:apply-templates select="text()|*"/>
		</div>
	</xsl:if>
	<xsl:if test="not(@show='yes')">
		<div style="visibility: hidden;display:none;" class="{@classprefix}_box" id="{@id}">
			<xsl:apply-templates select="text()|*"/>
		</div>
	</xsl:if>
</xsl:template>

<xsl:template match="widget:tabs">
	<div class="{@classprefix}_tabs">
		<xsl:for-each select="widget:tab">
			<xsl:choose>
				<xsl:when test="position()=1">
					<span id="{@id}_title" class="{../@classprefix}_tabtitle_selected"><a href="javascript:activate('{@id}','{../@classprefix}_tabtitle','{../@classprefix}_tabtitle_selected');"><xsl:value-of select="@name"/></a></span> 
				</xsl:when>
				<xsl:otherwise>
					<span id="{@id}_title" class="{../@classprefix}_tabtitle"><a href="javascript:activate('{@id}','{../@classprefix}_tabtitle','{../@classprefix}_tabtitle_selected');"><xsl:value-of select="@name"/></a></span> 
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
		<div class="{@classprefix}_tabcontents">
			<xsl:for-each select="widget:tab">
				<xsl:choose>
					<xsl:when test="position()=1">
						<div id="{@id}" class="{../@classprefix}_tabcontent"><xsl:apply-templates select="text()|*"/></div>
					</xsl:when>
					<xsl:otherwise>
						<div id="{@id}" style="visibility: hidden;display:none;" class="{../@classprefix}_tabcontent"><xsl:apply-templates select="text()|*"/></div>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
		</div>
	</div>
</xsl:template>

<xsl:template match="widget:rtabs">
	<div class="{@classprefix}_tabs">
		<div class="{@classprefix}_tabcontents">
			<xsl:for-each select="widget:tab">
				<xsl:choose>
					<xsl:when test="position()=1">
						<div id="{@id}" class="{../@classprefix}_tabcontent"><xsl:apply-templates select="text()|*"/></div>
					</xsl:when>
					<xsl:otherwise>
						<div id="{@id}" style="visibility: hidden;display:none;" class="{../@classprefix}_tabcontent"><xsl:apply-templates select="text()|*"/></div>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
		</div>
		<div class="{@classprefix}_tabtitles">
			<xsl:for-each select="widget:tab">
				<xsl:choose>
					<xsl:when test="position()=1">
						<span id="{@id}_title" class="{../@classprefix}_tabtitle_selected"><a href="javascript:activate('{@id}','{../@classprefix}_tabtitle','{../@classprefix}_tabtitle_selected');"><xsl:value-of select="@name"/></a></span> 
					</xsl:when>
					<xsl:otherwise>
						<span id="{@id}_title" class="{../@classprefix}_tabtitle"><a href="javascript:activate('{@id}','{../@classprefix}_tabtitle','{../@classprefix}_tabtitle_selected');"><xsl:value-of select="@name"/></a></span> 
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
		</div>
	</div>
</xsl:template>

<xsl:template match="widget:link">
	<xsl:element name="a">
		<xsl:attribute name="href"><xsl:value-of select="@href"/></xsl:attribute>
		<xsl:if test=".=''">
			<xsl:value-of select="@href"/>
		</xsl:if>
		<xsl:value-of select="."/>
	</xsl:element>
</xsl:template>

<xsl:template match="*">
	<xsl:copy-of select="."/>
</xsl:template>

</xsl:stylesheet>